{****************************************************************************}
{                            Data Master 2000                                }
{****************************************************************************}
unit BindU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, dm_tlb, StdCtrls, Buttons, 
  comobj{$ifdef VER140}, Variants{$endif};

type
  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    {$ifdef LATEBINDING}
    Server: Variant;
    {$else}
    // Server: TDMApplication;  same performance as IDMApplication!
    Server: IDMApplication;
    {$endif}
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
 {$ifdef LATEBINDING}
  Server:=CreateOleObject('DM.DMApplication');
 {$else}
//  Server:=TDMApplication.Create(Self);
  Server:=CoDMApplication.Create;
 {$endif}
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
var Doc: IDMDocument; Wks: IDMWorksheet; Cnt: IDMContainer; i,j,k: integer;
begin
  j:=gettickcount;


 {$ifdef LATEBINDING}
  Server.CreateDocument('');
  Server.ActiveDocument.WindowCaption:='Data generated from Delphi application!';
  Server.ActiveDocument.WindowState:=dwsWorksheet;
  Server.ActiveDocument.worksheet.ColumnLabels[1]:='X';
  Server.ActiveDocument.worksheet.ColumnLabels[2]:='X^2';
  Server.ActiveDocument.Container.Clear;
  for i:=0 to 99 do
  begin
    // Server.ActiveDocument.Container.AddItem(inttostr(i)+' '+inttostr(i*i));
    // conversion string=>array doesn't affect performance
    Server.ActiveDocument.Container.AddItem(VarArrayOf([i, i*i]));
    if (i mod 9)=0 then // refresh doesn't affect performance
    begin Label1.caption:=inttostr(i); Label1.refresh; end;
  end;
  Server.ActiveDocument.Container.Modified:=true;

  k:=gettickcount;

  for i:=0 to 99 do
  begin
    //Server.ActiveDocument.Container.Items[i]:=inttostr(i)+' '+inttostr(i*i);
    Server.ActiveDocument.Container.Items[i]:=VarArrayOf([i, i*i, i/2]);
    if (i mod 9)=0 then
    begin Label1.caption:=inttostr(i); Label1.refresh; end;
  end;
  Server.ActiveDocument.Container.Modified:=true;

 {$else}


  Doc:=Server.CreateDocument('') as IDMDocument;
  with doc do
  begin
    WindowCaption:='Data generated from Delphi application!';
    WindowState:=dwsWorksheet;
    Wks:=Worksheet as IDMWorksheet;  // implicit QueryInterface()
    cnt:=Container as IDMContainer;
    Wks.ColumnLabels[1]:='X';
    Wks.ColumnLabels[2]:='X^2';
    Cnt.Clear;
    for i:=0 to 99 do
    begin
      Cnt.AddItem(VarArrayOf([i, i*i]));
      if (i mod 9)=0 then
      begin Label1.caption:=inttostr(i); Label1.refresh; end;
    end;
    Cnt.Modified:=true;

    k:=gettickcount;

    for i:=0 to 99 do
    begin
      Cnt.Items[i]:=VarArrayOf([i, i*i, i/2]);
      if (i mod 9)=0 then
      begin Label1.caption:=inttostr(i); Label1.refresh; end;
    end;
    Cnt.Modified:=true;

    Cnt:=nil;  // implicit Release()
    wks:=nil;
  end;
  Doc:=nil;
 {$endif}

  Label1.caption:='Add: '+inttostr(k-j)+' Change: '+inttostr(gettickcount-k);
end;

end.
