{****************************************************************************}
{                            Data Master 2000                                }
{****************************************************************************}
unit DDEU;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, DdeMan, Buttons, ExtCtrls;

type
  TDDEForm = class(TForm)
    CloseBitBtn: TBitBtn;
    FileOpenDialog: TOpenDialog;
    OpenBitBtn: TBitBtn;
    DdeClientConv: TDdeClientConv;
    StatusLine: TStaticText;
    MessageButton: TButton;
    MessageEdit: TEdit;
    SettingsButton: TButton;
    SettingsMemo: TMemo;
    UpSpeedButton: TSpeedButton;
    DownSpeedButton: TSpeedButton;
    Label1: TLabel;
    Display: TStaticText;
    Timer: TTimer;
    OpenDDEBitBtn: TBitBtn;
    DDEOpenDialog: TOpenDialog;
    procedure DdeClientConvOpen(Sender: TObject);
    procedure DdeClientConvClose(Sender: TObject);
    procedure OpenBitBtnClick(Sender: TObject);
    procedure MessageButtonClick(Sender: TObject);
    procedure SettingsButtonClick(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure SpeedButtonClick(Sender: TObject);
    procedure OpenDDEBitBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    procedure ExecDDE(Data, Name, Value: string);
  public
    { Public declarations }
  end;

var DDEForm: TDDEForm;


implementation

{$R *.dfm}

procedure TDDEForm.DdeClientConvOpen(Sender: TObject);
begin
  Statusline.Caption:='DDE session opened';
  OpenBitBtn.Enabled:=true;
  MessageButton.Enabled:=true;
  SettingsButton.Enabled:=true;
  UpSpeedButton.Enabled:=true;
  DownSpeedButton.Enabled:=true;
end;

procedure TDDEForm.DdeClientConvClose(Sender: TObject);
begin
  OpenBitBtn.Enabled:=false;
  MessageButton.Enabled:=false;
  SettingsButton.Enabled:=false;
  UpSpeedButton.Enabled:=false;
  DownSpeedButton.Enabled:=false;
  UpSpeedButton.Down:=false;
  DownSpeedButton.Down:=false;
  Timer.Enabled:=false;
  Statusline.Caption:='DDE session closed';
end;

procedure TDDEForm.OpenBitBtnClick(Sender: TObject);
begin
  if FileOpenDialog.Execute then ExecDDE('','Open',FileOpenDialog.FileName);
end;

procedure TDDEForm.ExecDDE(Data, Name, Value: string);
var Cmd: array[0..2048] of char;
begin
  StrPCopy(Cmd, Name+'='+Value+#13#10+Data);
  if not DdeClientConv.ExecuteMacro(Cmd, False) then
  MessageDlg('Unable to Execute Macro!', mtError, [mbCancel], 0);
end;

procedure TDDEForm.MessageButtonClick(Sender: TObject);
begin
  ExecDDE('','MESSAGE',MessageEdit.Text);
end;

procedure TDDEForm.SettingsButtonClick(Sender: TObject);
begin
  ExecDDE(SettingsMemo.Text,'EXPSETTINGS',' ');
end;

procedure TDDEForm.TimerTimer(Sender: TObject);
begin
  Display.Caption:='Number='+IntToStr(Display.Tag)+#13#10+
  'Value='+FloatToStr(Display.Tag*(Random+4));
  ExecDDE(Display.Caption,'DATA','2');
  if UpSpeedButton.Down then Display.Tag:=Display.Tag+1
  else Display.Tag:=Display.Tag-1;
end;

procedure TDDEForm.SpeedButtonClick(Sender: TObject);
begin
  Timer.Enabled:=UpSpeedButton.Down or DownSpeedButton.Down;
end;

procedure TDDEForm.OpenDDEBitBtnClick(Sender: TObject);
begin
{ if DDEClientConv.ConnectMode is automatic, there's no need in this handler.
  However, in this case you need to start DM2000 manually prior to this test}
  if not DDEOpenDialog.Execute then Exit;
  DDEClientConv.ServiceApplication:=DDEOpenDialog.FileName;
  DDEClientConv.OpenLink;
end;

procedure TDDEForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  DDEClientConv.CloseLink;
end;

end.
