{****************************************************************************}
{                            Data Master 2000                                }
{****************************************************************************}
unit ImpMainU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls, Buttons, DM_TLB,
  {$ifdef VER140}Variants, {$endif}Common;

type
  TMainForm = class(TForm)
    CloseBitBtn: TBitBtn;
    Timer: TTimer;
    FStartEdit: TEdit;
    FStepEdit: TEdit;
    FStopEdit: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    REdit: TEdit;
    Label5: TLabel;
    CEdit: TEdit;
    NewFileBitBtn: TBitBtn;
    NextSerieBitBtn: TBitBtn;
    SetButton: TButton;
    StartStopBitBtn: TBitBtn;
    StatusBar: TStatusBar;
    procedure FormCreate(Sender: TObject);
    procedure NewFileBitBtnClick(Sender: TObject);
    procedure SetButtonClick(Sender: TObject);
    procedure NextSerieBitBtnClick(Sender: TObject);
    procedure StartStopBitBtnClick(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
  private
    { Private declarations }
    DM: TDMApplication;
    RWin,XWin: IDMDocument;
    R,C,F0,F1,FS,F: extended;
    SerCounter: integer;
    SerBufR,SerBufX: IDMSerie;
    ContBufR: IDMContainer;
    procedure Command(Sender: TObject; var Command: OleVariant);
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.Command(Sender: TObject; var Command: OleVariant);
begin
  StatusBar.Panels[1].Text:=Command;
  if Command='EXPSETTINGS' then DM.SetExpSettings('R: '+FloatToStr(R)+CRLF+
  'C: '+FloatToStr(C)+CRLF+'F0: '+FloatToStr(F0)+CRLF+'F1: '+FloatToStr(F1));
  if (Command='TIMER') and StartStopBitBtn.Enabled then StartStopBitBtn.Click;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  DM:=TDMApplication.Create(Self);
  DM.OnCommand:=Command;
  DM.Connect;
end;

procedure TMainForm.NewFileBitBtnClick(Sender: TObject);
var I: integer;
begin
  StatusBar.Panels[1].Text:='Working...'; StatusBar.Refresh;
  DM.ExecuteCommand('MinimizeAllAction');
  RWin:=DM.CreateDocument('') as IDMDocument;
  RWin.WindowCaption:='R(F)';
  RWin.WindowState:=dwsPlot;
  XWin:=DM.CreateDocument('') as IDMDocument;
  XWin.WindowCaption:='X(F)';
  XWin.WindowState:=dwsPlot;
  DM.ExecuteCommand('TileVerticalAction');
  with RWin.Worksheet as IDMWorksheet do
  begin
    ColumnLabels[1]:='R, Ohm';
    ColumnLabels[2]:='X, Ohm';
    ColumnLabels[3]:='F, MHz';
    XColumn:=3;
    YColumn:=1;
  end;
  with XWin.Plot as IDMPlot do
  begin
    for I:=0 to SerieCount-1 do
    (Series[I] as IDMSerie).Container:=RWin.Container;
    (XAxis as IDMAxis).AutoScale:=false;
    (YAxis as IDMAxis).AutoScale:=false;
  end;
  SerCounter:=-1;
  with RWin.Plot as IDMPlot do
  begin
    (XAxis as IDMAxis).AutoScale:=false;
    (YAxis as IDMAxis).AutoScale:=false;
  end;
  RWin.IsRecording:=true;
  (DM.Notes as IDMNotes).AddLine('New file created');
  SetButton.Click;
  NextSerieBitBtn.Click;
  StatusBar.Panels[1].Text:='Ready';
  ContBufR:=(RWin.Container as IDMContainer); // save ref. to accelerate
  SetButton.Enabled:=true; StartStopBitBtn.Enabled:=true;
  NextSerieBitBtn.Enabled:=true;
end;

procedure TMainForm.SetButtonClick(Sender: TObject);
begin
  R:=StrToFloat(REdit.Text); C:=StrToFloat(CEdit.Text);
  F0:=StrToFloat(FStartEdit.Text); F1:=StrToFloat(FStopEdit.Text);
  FS:=StrToFloat(FStepEdit.Text);
  with RWin.Plot as IDMPlot do
  begin
    (XAxis as IDMAxis).Min:=F0; (XAxis as IDMAxis).Max:=F1;
  end;
  with XWin.Plot as IDMPlot do
  begin
    (XAxis as IDMAxis).Min:=F0; (XAxis as IDMAxis).Max:=F1;
  end;
end;

procedure TMainForm.NextSerieBitBtnClick(Sender: TObject);
begin
  if (SerCounter>=0) then // called by button
  begin
    if (((RWin.Plot as IDMPlot).Series[SerCounter] as IDMSerie).IsEmpty or
       ((XWin.Plot as IDMPlot).Series[SerCounter] as IDMSerie).IsEmpty or
       ((RWin.Container as IDMContainer).ItemCount<2)) then Exit;
   ((RWin.Plot as IDMPlot).Series[SerCounter] as IDMSerie).IsRecording:=false;
   ((XWin.Plot as IDMPlot).Series[SerCounter] as IDMSerie).IsRecording:=false;
    Inc(SerCounter);
    with ((RWin.Plot as IDMPlot).Series[SerCounter] as IDMSerie) do
    begin
      IsRecording:=true; XColumn:=3; YColumn:=1;
      FirstLine:=(RWin.Container as IDMContainer).ItemCount-1;
    end;
    with ((XWin.Plot as IDMPlot).Series[SerCounter] as IDMSerie) do
    begin
      IsRecording:=true;  XColumn:=3; YColumn:=2;
      FirstLine:=(RWin.Container as IDMContainer).ItemCount-1;
    end;
    (DM.Notes as IDMNotes).AddLine('Next serie started');
  end else   // called from NewFileBitBtnClick()
  begin
    Inc(SerCounter);
    with ((RWin.Plot as IDMPlot).Series[SerCounter] as IDMSerie) do
    begin IsRecording:=true; XColumn:=3; YColumn:=1; end;
    with ((XWin.Plot as IDMPlot).Series[SerCounter] as IDMSerie) do
    begin IsRecording:=true; XColumn:=3; YColumn:=2; end;
  end;
  SerBufR:=(RWin.Plot as IDMPlot).Series[SerCounter] as IDMSerie;
  SerBufX:=(XWin.Plot as IDMPlot).Series[SerCounter] as IDMSerie;
end;

procedure TMainForm.StartStopBitBtnClick(Sender: TObject);
begin
  if Timer.Enabled then StartStopBitBtn.Caption:='Start' else
  StartStopBitBtn.Caption:='Stop';
  Timer.Enabled:=not Timer.Enabled;
  DM.IsCommandChecked['RunAction']:=Timer.Enabled;
end;

procedure TMainForm.TimerTimer(Sender: TObject);
begin
  if ((F>F1) and (FS>0)) or ((F<F0) and (FS<0))
  then begin StartStopBitBtn.Click; Exit; end;
  F:=F+FS; StatusBar.Panels[0].Text:='Frequency='+FloatToStr(F);
  {$ifdef latebinding}
  (RWin.Container as IDMContainer).AddItem(VarArrayOf([
  R+( 1/(3*R) / (1/(9*R*R)+F*C*F*C) ), F*C / (1/(9*R*R)+F*C*F*C),F]));
  ((RWin.Plot as IDMPlot).Series[SerCounter] as IDMSerie).AddPoint;
  ((XWin.Plot as IDMPlot).Series[SerCounter] as IDMSerie).AddPoint;
  (RWin.Container as IDMContainer).Modified:=true;
  {$else}
  ContBufR.AddItem(VarArrayOf([
  R+( 1/(3*R) / (1/(9*R*R)+F*C*F*C) ), F*C / (1/(9*R*R)+F*C*F*C),F]));
  SerBufR.AddPoint;
  SerBufX.AddPoint;
  ContBufR.Modified:=true;
  {$endif}
end;

end.
