/*****************************************************************
*   This script calculates and plots "best fit line" for current *
* serie. Unlike embedded best fit line available from serie      *
* properties dialog box it uses only points within selected plot *
* area. If current serie or plot selection is empty it will      *
* produce appropriate error message.                             *
* In addition this script demonstrates how to use arrays in      *
* JScript. The problem is that original JavaScript from Netscape *
* has no array type, and you have to use Array objects instead.  *
* Microsoft extends JavaScript so you can use regular variant    *
* arrays, but with some limitations (see JScript reference).     *
*   Note that serie expressions must be empty!                   *
*****************************************************************/

function BestFit()
{
if (!Server.ActiveDocument) return 'No document active!';

var plot=Server.ActiveDocument.Plot;
if ((plot.XAxis.Expression!='')||(plot.YAxis.Expression!='')) 
   return 'Non-empty axis expressions not allowed!';

var ser=Server.ActiveDocument.Plot.CurrentSerie;
if (ser.IsEmpty) return 'Current serie is empty!';
if ((ser.XExpression!='')||(ser.YExpression!='')) 
   return 'Non-empty serie expressions not allowed!';

var i,n=0; // counters
var x,y,v1,v2; // item buffers
var bfX=0, bfY=0, bfXY=0, bfX2=0; // best fit sums
var x1,x2,y1,y2; // plot selection
var bfA,bfB; // line coefficients

x1=plot.SelectionLeft;
x2=plot.SelectionRight;
y1=plot.SelectionBottom;
y2=plot.SelectionTop;

for (i=ser.FirstLine;i<=ser.LastLine;i++)
{
  v1=ser.Container.Items(i);  // in v1 - variant array
  v2=v1.toArray(); // in v2 - regular JS array object
  x=v2[ser.XColumn-1]; y=v2[ser.YColumn-1]; // 0-based!
  if ((x>=x1)&&(x<=x2)&&(y>=y1)&&(y<=y2))
  {
    n++; bfX+=x; bfY+=y; bfXY+=x*y; bfX2+=x*x;
  }
}

if (n==0) return 'No points selected!';

bfA=n*bfX2-bfX*bfX;
if (bfA==0) return 'Unable to calculate best fit!';
bfA=(n*bfXY-bfX*bfY)/bfA; bfB=(bfY-bfA*bfX)/n;

// show best fit in last serie. If it's nonempty, add new
ser=plot.Series(plot.SerieCount-1);
if (!ser.IsEmpty) 
{ plot.AddSerie(); ser=plot.Series(plot.SerieCount-1); }
ser.IsFunction=true; ser.Text='Best fit';
ser.YExpression='cx*'+bfA+'+'+bfB;

Server.DisplayMessage(ser.YExpression);
Server.Notes.AddLine('\r\n--------------------------------');
Server.Notes.AddLine('x1: '+x1+'; x2: '+x2);
Server.Notes.AddLine('Fit: Y=X*'+bfA+'+'+bfB);

}