'===================================================
'This script should be used as part of procedure of
'lorentzian peak + base line fitting. This routine
'should be used when peak imposed over strong base
'line with relative magnitude comparable with peak
'size, and is divided into several simple steps.

'1. Plot your curve with peak into current serie
'(you may use peak data from weight.dmw desktop)
'2. Select peak area with plot selector tool
'3. Run MakeBase procedure (compile if need)
'after this step all points except ones inside 
'selected plot area fitted with fifth-power
'polynomial expression, and serie expression 
'modified to subtract this linear fit from curve
'You should see only peak w/o base at this point!
'4. UNCHECK plot selector tool and run Lorentzian
'LM fitter. Click "Update" to ensure parameters
'initial approximation seems to be good and if so,
'fit peak as usual.
'===================================================

sub MakeBase

if Server.DocumentCount=0 then MsgBox "No document active!" : exit sub

set doc=Server.ActiveDocument
set plot=doc.Plot
set ser=doc.Plot.CurrentSerie

if ser.IsEmpty then MsgBox "Current serie is empty!" : exit sub

dim i,j,x,y,n,x1,x2,y1,y2,AY,AX,R(5),Dev,Res,expr

n=0 ' point counter

x1=plot.SelectionLeft 
x2=plot.SelectionRight
y1=plot.SelectionBottom
y2=plot.SelectionTop

' 1st cycle - find points number
for i=ser.FirstLine to ser.LastLine
  ser.GetPoint i,x,y
  if not ((x>=x1) and (x<=x2) and (y>=y1) and (y<=y2)) then
     n=n+1 
  end if
next

ReDim AX(n-1)  
ReDim AY(n-1)

' 2nd cycle - fill array
j=0
for i=ser.FirstLine to ser.LastLine
  ser.GetPoint i,x,y
  if not ((x>=x1) and (x<=x2) and (y>=y1) and (y<=y2)) then
     AX(j)=x
     AY(j)=y
     j=j+1
  end if
next

call Server.LinearFit(AX,AY,6,0,R,Dev,Res)

expr="cy-(" & R(0) & "+cx*" & R(1) & "+cx^2*" & R(2)
expr=expr & "+cx^3*" & R(3) & "+cx^4*" & R(4) & "+cx^5*" & R(5) & ")"
ser.YExpression=expr 

end sub