' This script measures relative noise ratio.
' Notice that measurement algorithm is very
' simple and sometimes may be incorrect: it
' just calculates <dY>/<Y>*100% by selected
' array of points and assumes that dY noise
' is much greater than dY curve slope.
' You may easily improve this script - use
' linear fitter to subtract real curve slope
' and to obtain more realistic results.

function Noise

if Server.DocumentCount=0 then Noise="No document active!" : exit function

set doc=Server.ActiveDocument
set plot=doc.Plot
set ser=doc.Plot.CurrentSerie

if ser.IsEmpty then Noise="Current serie is empty!" : exit function

n=0          ' counter of selected points
acc=0        ' Y  accumulator
delta=0      ' dY accumulator
y0=0         ' previous Y value

x1=plot.SelectionLeft
x2=plot.SelectionRight

for i=ser.FirstLine to ser.LastLine
  ser.GetPoint i,x,y
  if ((x>=x1) and (x<=x2)) then
     if n>0 then delta=delta+abs(y0-y)
     y0=y
     n=n+1 
     acc=acc+abs(y)
  end if
next

if n<10 then Noise="You need to select >10 points!" : exit function

res="Signal/Noise ratio=" & Round(delta/acc*100,3) & "% by " & n &  " points"

'Noise=res  output into messagebox !!!

Server.DisplayMessage(res)

end function

