/* 

This script demonstrates using variant arrays in JS.
The problem is that original Netscape JS have no
intrinsic Array type; instead, it offers array objects.
However, in ActiveX environment "objects" represented 
by interface pointers; but there's a native array type.

See VB reference for more info about types and "variants".

Arrays are important since many ActiveX properties and 
methods have appropriate parameters. In DM2000, 
Container.Items property is a Variant array. Using
string representation may force undesirable precision 
losses during type conversion.

To experiment with this script, create Data Window with
some value in 0A cell (actual number of decimal signs
should be greater then displayed - use column format
in the Worksheet properties dialog box). You may run
MakeData() function to create such window. Call ReadData()
and see difference between strings and VarArrays.

*/


function MakeData()
{
var D=Server.CreateDocument("");
var C=D.Container; 
C.AddItem('1.000123456789');
}


function ReadData()
{
var C=Server.ActiveDocument.Container; 
var V=C.Items(0);   // C.Items(0) returns Variant array
var S=C.Strings(0); // C.Strings(0) returns string representation
var VV=V.toArray();
return 'Strings: '+S+'; Items: '+VV[0];
}